/*  DOMOCHRIS.fr

 Radio Reveil MP3
 liste materiel: 
 Dfplayer Mini, (10, 11)RX, TX
 afficheur TM1638,define a afficheur on data pin 8, clock pin 9 and strobe pin 7 Afficheur
 Tyni RTC I2C , A4 SDA, A5 SCL
  
V1 : 26/01/2016 Radio reveille Léonie, affichage TM1338, RTC, MP3, Alarme, 
V2: rajout servo pin 3 
*/
#include <Servo.h>
#include <TM1638.h>

// Date and time functions using a DS1307 RTC connected via I2C and Wire lib
#include <Wire.h>
#include "RTClib.h"

#include "MP3.h"

#include "Afficheur.h"


#if defined(ARDUINO_ARCH_SAMD)
// for Zero, output on USB Serial console, remove line below if using programming port to program the Zero!
   #define Serial SerialUSB
#endif

Servo myservo;  // create servo object to control a servo
byte pos = 0;    // variable to store the servo position 

RTC_DS1307 rtc; //RTC A4 SDA A5 SCL

char daysOfTheWeek[7][12] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

byte Heures;
byte Minutes;

//alarme
short initAlarmeH = 88; //stock 0-256  heure
short initAlarmeM = 88; //stock 0-256  Minutes
boolean AlarmeTmp = true; //flag déclenchement 1 fois son Alarme

// define a afficheur on data pin 8, clock pin 9 and strobe pin 7 Afficheur
TM1638 afficheur(8, 9, 7);

#include <SoftwareSerial.h>

SoftwareSerial mySerial(10, 11); // RX, TX

  //Bouton appuie long
   unsigned short temps_defini = 5000;   //définition du temps de maintien désiré en ms
   int boutonPin1 = 3;  //pin du bouton
   long debut_appui1;
   boolean variable1 = false;
   byte etat_bouton1;
   byte dernier_etat_bouton1 = LOW;
   byte etat_led1 = LOW;
   byte Menu = 0; //Menu :0=pas d'appuie long, 1=appuie long, 2,3,4 etc different >Menu
   byte MenuMax = 1; //nombre de menu
byte keys;
//int Volume; //var Volume
byte Volume2; //var Volume
byte VolumeAlarme = 15;// volume alarme
byte VolumeAlarmePLus = 10; //rajout de volume au bout d'une minutes aprés l'alarme
byte DemarageVolume = 0;
boolean Alarme = false; //variable alarme =1 == on
byte playNext = false; //flage retitient si c'est 1ere fois appuie=>play revient a 0 si stop sinon next

void setup() {
  Serial.begin(9600);
  mySerial.begin (9600); //MP3

  initMP3(mySerial, 10);

  // This line sets the RTC with an explicit date & time, for example to set
  // January 21, 2014 at 3am you would call:
  // rtc.adjust(DateTime(2014, 1, 21, 3, 0, 0));
  if (! rtc.begin()) {
    Serial.println("Couldn't find RTC");
    while (1);
  }

  if (! rtc.isrunning()) {
    Serial.println("RTC is NOT running!");
    // following line sets the RTC to the date & time this sketch was compiled
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    // This line sets the RTC with an explicit date & time, for example to set
    // January 21, 2014 at 3am you would call:
    // rtc.adjust(DateTime(2016, 1, 26, 13, 05, 0));
  }

  //démarrage affichage
  afficheur.clearDisplay(); 
  delay(300);
  afficheur.setDisplayToString("HELLO");
  delay(1000);

  afficheur.setLEDs(0b11111111 | 0b00000000<< 8 );
  delay(300);
  afficheur.clearDisplay(); 
  delay(300);
  afficheur.setDisplayToString("     LEO");
  delay(1000);
  afficheur.clearDisplay(); 
  delay(300);


  myservo.attach(3);  // attaches the servo on pin 3 to the servo object

  //servo
  for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
  } 
  //servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
 {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
 } 
 
 //servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
 {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
 } 
 
 myservo.detach();  // attaches the servo on pin 3 to the servo object

}

void loop() {
 // rtc.adjust(DateTime(2016, 1, 26, 15, 5, 0));
Heure_RTC(); //lecture heure RTC
DateTime now = rtc.now();

DateTime alarme (now.year(), now.month(), now.day(), initAlarmeH, initAlarmeM);

afficher(afficheur, now, alarme, Alarme);

Volume();
Bouton();
Alarme2();
}

void Bouton(){
   //bouton
  byte keys = afficheur.getButtons();

  // light the first 4 red LEDs and the last 4 green LEDs as the buttons are pressed
  afficheur.setLEDs(((keys & 0xF0) << 8) | (keys & 0xF));
  //Serial.println(keys);


//BoutonLong
     //etat_bouton1 = digitalRead(boutonPin1);                        //lecture de l'état des boutons
     if (keys == 2){ //Bouton S2
     etat_bouton1 = HIGH ;                        //lecture de l'état du bouton s2
     }
     else
     etat_bouton1 = LOW ;
      if (etat_bouton1 == HIGH && dernier_etat_bouton1 == LOW){      //détection de l'appui sur le bouton 1
         debut_appui1 = millis();                                   //initialisation du compteur 1
         variable1 = true;          //enregistrement du changement d'état du bouton 1
         Serial.println("appuie bouton");
         
         if (Menu >=1){
           Menu = (Menu + 1) ;
           Serial.print("Menu = ");
           Serial.println(Menu);
           if (Menu >= MenuMax)
                             {
                               Menu = 0; //on revient a 0
                                Serial.print("Menu sort = ");
                                Serial.println(Menu);

                                //chenillard droite gauche pour sortie du menu
                                afficheur.setLEDs(0b00000000 | 0b10000000<< 8 ); //Chenillard led rouge derniere vers 1ere
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11000000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11100000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11110000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111100<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111110<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111111<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b00000000<<8 );
};
                             }
                               
                       }
          
    
   
   
      if ( variable1 == true && etat_bouton1 == HIGH && dernier_etat_bouton1 == HIGH){    //le bouton 1 était et est toujours appuyé
                                                                                 
         if ((millis() - debut_appui1) >= temps_defini){             //est-ce que le temps choisi est écoulé ?                                 
            etat_led1 = HIGH;                              //déclaration d'allumage de la led 1 
            //delay(2000);
                                      
            if (Menu == 0){
                           Menu = 1; //on rentre dans le menu aprés appuie long
                           Serial.print("Menu rentre = ");
                           Serial.println(Menu);
//chenillard gauche droite entree menu
afficheur.setLEDs(0b00000001 | 0b00000000<<8 );//Chenillard led vers 1ere led vers derniere
 delay(100);     
 afficheur.setLEDs(0b00000011 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00000111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00001111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00011111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00111111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b01111111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b11111111 | 0b00000000<<8 );
 delay(100); 
                           
                           }
               
         }             
      }
      
      if (etat_bouton1 == LOW){                              //extinction de la led 1 si le bouton est relaché
         etat_led1 = LOW;
      }
      
      dernier_etat_bouton1 = etat_bouton1;                       //actualisation de l'état du bouton

if (Menu == 0){
  
//Serial.println(Volume);
if (keys == 1){ //Bouton S1
  setMP3Volume (Volume2);  //0-30
/*  if (playNext== false){
*/    
 delay(300);
  randomMP3(); //random
 delay(300);
/*
  playNext = true;
  delay(300);
 }
 else
  delay(300);
  nextMP3();
 delay(300);
 */
 /*if (playNext== false){
 

  playNext = true;
  delay(300);
 }
 else
    prevMP3 (); //
    delay(300);
*/
    myservo.attach(3);  // attaches the servo on pin 3 to the servo object
//servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 

 myservo.detach();  // attaches the servo on pin 3 to the servo object 
    
}

if (keys == 2){ //Bouton S1
    stopMP3 ();
    delay(300);
    if (playNext== true){
      playNext = false;
    }
    
       myservo.attach(3);  // attaches the servo on pin 3 to the servo object
//servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 

 myservo.detach();  // attaches the servo on pin 3 to the servo object 
 
    
}


if (keys == 4){ //Bouton S2

    Volume2 = Volume2 - 1;
    if (Volume2<0){
      Volume2=0;
      
    }
    setMP3Volume (Volume2);  //0-30
    delay(300);

}

if (keys == 8){ //Bouton S2
    Volume2 = Volume2 + 1;
     if (Volume2>=30){
      Volume2=30;
      
    }
    setMP3Volume (Volume2);  //0-30
    delay(300);

}

//bouton droite
  if (keys == 16){ //Bouton S5 Alarm on/off
    // Serial.println("toto");
    Alarme = 1 - Alarme;
    afficheur.clearDisplay(); 
    delay(300);
  }


 if (keys == 32){ //Bouton S6
    // Serial.println("toto");
    if (Alarme == true){
    initAlarmeH = initAlarmeH + 1;
    if (initAlarmeH>23){
      initAlarmeH = 0;
    }
    delay(300);
  }
 }

  if (keys == 64){ //Bouton S7
    if (Alarme == true){
    initAlarmeM = initAlarmeM + 1;
    if (initAlarmeM>59){
      initAlarmeM = 0;
    }
    delay(300);
  }
  }

  if (keys == 128){ //Bouton S8
if (Alarme == true){
    initAlarmeM = initAlarmeM - 1;
     if (initAlarmeM<0){
      initAlarmeM = 59;
    }
    if (initAlarmeM>59){
      initAlarmeM = 0;
    }
    
    delay(300);
  }
  }
}

if (Menu == 1){ //aprés apuie long
 // Serial.println("toto");
//Bouton gauche
  if (keys == 16){ //Bouton S1
  //  mp3_prev ();
  Heures = Heures + 1;
    if (Heures>23){
      Heures =0;
    }
     DateTime now = rtc.now(); //RTC
     rtc.adjust(DateTime(now.year(), now.month(), now.day(), Heures, now.minute(), 0));
    
    delay(300);
  }

  if (keys == 32){ //Bouton S2
    Heures = Heures - 1;
    if (Heures <0){
      Heures = 23;
    }
    DateTime now = rtc.now(); //RTC
    rtc.adjust(DateTime(now.year(), now.month(), now.day(), Heures, now.minute(), 0));
    delay(300);
  }
  if (keys == 64){ //Bouton S3
    Minutes = Minutes + 1;
    if (Minutes > 59){
      Minutes = 0;
    }
    DateTime now = rtc.now(); //RTC
    rtc.adjust(DateTime(now.year(), now.month(), now.day(), now.hour(), Minutes, 0));
    delay(300);


  }
  if (keys == 128){ //Bouton S4
    Minutes = Minutes - 1;
    if (Minutes < 0){
      Minutes = 59;
    }
    if (Minutes > 59){
      Minutes = 0;
    }
    DateTime now = rtc.now(); //RTC
    rtc.adjust(DateTime(now.year(), now.month(), now.day(), now.hour(), Minutes, 0));
    delay(300);
  }


  
}



  
  
}


void Heure_RTC(){
  
DateTime now = rtc.now(); //RTC
Heures = now.hour();
Minutes = now.minute();
   
}

void Volume(){
if (DemarageVolume == 0){ //demarrage volume = 10
  Volume2 = 10;
  DemarageVolume = 1;
}
  
Volume2; //sauvegarde memoire Volume2
 }

void Alarme2(){ //declenchement de l'alarme

if (Alarme == true){

  
if (( initAlarmeH == Heures) & (initAlarmeM == Minutes)& (AlarmeTmp == true)){
 Serial.print("alarmesssssss");
 setMP3Volume (VolumeAlarme);  //0-30
 delay(300);
  randomMP3(); //random
 delay(300);
 
 /*delay(300);
 randomMP3(); //lanceent lecture aleatoir MP3
 delay(300);
  prevMP3 ();
 delay(300);
 */
 AlarmeTmp = false; //flag pour ne lancer qu'une fois la commande

 //chenillard
 
 afficheur.setLEDs(0b00000001 | 0b00000000<<8 );//Chenillard led vers 1ere led vers derniere
 delay(100);     
 afficheur.setLEDs(0b00000011 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00000111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00001111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00011111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b00111111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b01111111 | 0b00000000<<8 );
 delay(100);     
 afficheur.setLEDs(0b11111111 | 0b00000000<<8 );
 delay(100);   

 afficheur.clearDisplay(); 
  delay(300);
afficheur.setDisplayToString("DEBOUt");
delay(1000);

afficheur.setLEDs(0b00000000 | 0b10000000<< 8 ); //Chenillard led rouge derniere vers 1ere
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11000000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11100000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11110000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111000<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111100<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111110<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b11111111<< 8 );
delay(100); 
afficheur.setLEDs(0b00000000 | 0b00000000<<8 );


 afficheur.clearDisplay(); 
  delay(300);
afficheur.setDisplayToString("    LEO");
delay(1000);
/*
myservo.attach(3);  // attaches the servo on pin 3 to the servo object

//servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 
  //servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 
  //servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 
  myservo.detach();  // attaches the servo on pin 3 to the servo object
  */
}
}


if ((Alarme == true)& (( initAlarmeH != Heures) || (initAlarmeM != Minutes))){ //flag pour lancer une seul fois l'alarme
if (AlarmeTmp == false){
setMP3Volume((VolumeAlarme + VolumeAlarmePLus));  //0-30 on augmente le son de 10 au bout d'une minutes aprés déclenchement alarme
delay(300);

myservo.attach(3);  // attaches the servo on pin 3 to the servo object
//servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 
  //servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 
  //servo
 for(pos = 0; pos < 180; pos += 5)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    delay(20);                       // waits 15ms for the servo to reach the position 
     
  } 
 myservo.detach();  // attaches the servo on pin 3 to the servo object 
}
  AlarmeTmp = true;
}

}

