#include <SoftwareSerial.h>
#include "DFPlayer_Mini_Mp3.h"

#include "MP3.h"

void initMP3(SoftwareSerial& serial, byte initVolume) {
  mp3_set_serial (serial); //set softwareSerial for DFPlayer-mini mp3 module 
  delay(300);
  mp3_set_volume (initVolume);  //0-30
  delay(300);
  stopMP3();
  delay(300);
}

void setMP3Volume(byte volume) {
  mp3_set_volume(volume);
}

void prevMP3() {
  mp3_prev();
}

void stopMP3() {
  mp3_stop();
}

void randomMP3() {
  mp3_random_play ();
}

